#!/bin/sh
DMDIR=/share/Apps/DownloadManager/webui
DEPENDENCIES="busybox aria2 aria2-utils sqlite3 curl unrar"
do_chmod() {
    if [ -d "$DMDIR" ]; then
        echo -n "Setting File Permissions: "
        cd "$DMDIR"
        chown -R nobody:99 _tmp
    fi
    echo "Done<br>"
}

do_cleanup() {
    if [ -d "${DMDIR}/_tmp" ]; then
        echo -n "Cleaning up Log files: "
        cd "$DMDIR"/_tmp
        rm -f *
    fi
    echo "Done<br>"
}

download_dependencies() {
    if [ -f "/share/Apps/local/bin/ipkg" -a -e "/share/Apps/local/bin/ipkg" ];then
        for pkg in `echo "${DEPENDENCIES}"`
        do
            is_installed=`/share/Apps/local/bin/ipkg list_installed 2>&-|grep "^${pkg} -"|wc -l`
            if [ $is_installed -ne 1 ];then
                /share/Apps/local/bin/ipkg install -force-overwrite ${pkg} 2>&-
            fi
        done
    else
        echo "I-Pkg installation is required via CSI."
        exit
    fi
}

start_busybox() {
    if [ -f "/share/Apps/local/bin/busybox" ];then
        if [ ! -f "/bin/busybox_org" ]; then
            cp /bin/busybox /bin/busybox_org
        fi
        cp /share/Apps/local/bin/busybox /bin

        chmod a+x /bin/busybox
        /bin/busybox --install
        #patches for backward compatibility
        #for NMT apps
        rm /bin/su
        ln -s /bin/busybox_org /bin/su
        rm /usr/bin/wget
    fi
}

auto_start() {
    su -pm -c "cd $DMDIR;_scripts/auto_start.sh" nobody 1>"$DMDIR"/_tmp/output_as.log 2>"$DMDIR"/_tmp/error_as.log & echo $! > "$DMDIR"/_tmp/.pid
}

kill_auto_start()
{
    killall auto_start.sh
    killall aria2c
}

case "$1" in
    start)
    download_dependencies;
    start_busybox;
    do_chmod;
    do_cleanup;
    auto_start;
    ;;
    
    stop)
    kill_auto_start;
    exit
    ;;
    
    restart)
    kill_auto_start;
    do_chmod;
    do_cleanup;
    auto_start;
    ;;
esac
