#include <stdio.h>
#include <stdlib.h>

char gdata[1024];
static char *dodump(FILE *fp, long start,long count);
static int isBitSet(long bytes[256], int index);

static int isBitSet(long bytes[256], int index) {
    int byteNumber=index/8;
    int bitNumber=index%8;
    int bitMask=128 >> bitNumber;
    int byt=bytes[byteNumber];
    int bit=byt&bitMask;
    if (bit==0) return 0;
    return 1;
}

int main(int argc, char **argv)
{
    FILE *fp;
    int i, j, k, position;
    long numChunk;
    long bitfieldData[4096], bitfieldData_p[4096];
    long numInFlightPiece, bitfieldLength;
    long index_p, Length_p, bitfieldLength_p;
    long chunkLength, pieceLength, numberOfPieces;
    long long int completedLength, totalLength;

    if (argc <= 1) {
        puts("Usage: aria2cnfo .aria2_file");
        return 1;
    }

    fp = fopen(*(argv + 1), "rb");
    pieceLength = strtol(dodump(fp, 10, 4), NULL, 16);
    totalLength = strtoll(dodump(fp, 14, 8), NULL, 16);
    printf("%lld\n",totalLength);
    bitfieldLength = strtol(dodump(fp, 30, 4), NULL, 16);
    position=34;
    for(i=0;i<bitfieldLength;i++) {
        bitfieldData[i] = strtol(dodump(fp,position, 1), NULL, 16);
        position++;
    }
    numInFlightPiece = strtol(dodump(fp,position, 4), NULL, 16);
    position=position+4;
    numberOfPieces=(totalLength+pieceLength-1)/pieceLength;

    chunkLength = 16*1024;
    completedLength = 0;
    for(i=0;i<numInFlightPiece;i++){
        index_p = strtol(dodump(fp, position, 4), NULL, 16);
        position=position+4;
        Length_p = strtol(dodump(fp, position, 4), NULL, 16);
        position=position+4;
        bitfieldLength_p = strtol(dodump(fp, position, 4), NULL, 16);
        position=position+4;
        for(j=0;j<bitfieldLength_p;j++) {
            bitfieldData_p[j] = strtol(dodump(fp,position, 1), NULL, 16);
            position++;
        }
        numChunk=(Length_p - chunkLength - 1)/chunkLength;

        for(k=0; k < numChunk-1; ++k)
            if(isBitSet(bitfieldData_p, k)) completedLength += chunkLength;
        if(isBitSet(bitfieldData_p, numChunk-1))
        completedLength += Length_p - chunkLength * (numChunk-1);
    }
    for(i=0; i < numberOfPieces-1; ++i)
        if(isBitSet(bitfieldData, i))
            completedLength += pieceLength;

    if(isBitSet(bitfieldData, numberOfPieces-1))
        completedLength +=  totalLength - pieceLength * (numberOfPieces -1);

    printf("%lld\n",completedLength);

    return 0;
}

static char *dodump(FILE *fp,long start, long count) {
    int c, pos1;
    long x = 0L;
    char prtln[100];
    pos1=0;

    fseek(fp, start, SEEK_SET);
    while (((c = fgetc(fp)) != EOF) && (x != count))
    {
        sprintf(prtln+pos1, "%0.2X", c);
        pos1 +=2;
        x++;
    }
    sprintf(gdata, prtln);
    return gdata;
}
