<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

require_once "_lib/xmlrpc.inc";

function LoadLang() {
    global $homedir, $default_lang;

    LoadPreferences();
    $desc_array=file($homedir.'_lang/'.$default_lang.'.txt');
    $description = array();
    foreach($desc_array as $desc) {
        if (substr($desc,0,1) == "/" )
            continue;
        $des = explode("|",$desc);
        $description = array_push_assoc($description, $des[0], trim($des[1]));
    }
    return $description;
}

function LoadPreferences() {
    global $download_db;
    $dbh = new PDO('sqlite:'.$download_db);

    $sql = "SELECT * FROM preferences";
    $result = $dbh->query($sql);

    foreach ($result as $row)
        $GLOBALS[$row[0]]=$row[1];
    $dbh = NULL;
}

function array_push_assoc($array, $key, $value){
    $array[$key] = $value;
    return $array;
}

function setDownloadStatus($linkInput, $status) {
    global $download_db;

    $dbh = new PDO('sqlite:'.$download_db);
    $sql = "UPDATE links set status='".$status."', ";
    $sql .= "file_exists='Download ".$status."d' ";
    $sql .= "where link='".$linkInput."'";
    $result = $dbh->query($sql);
    $dbh = NULL;
}

function getXMLRPCdata($method, $gid) {
    if ($gid > 0)
        $message = new xmlrpcmsg($method, array(new xmlrpcval($gid, "string")));
    else
        $message = new xmlrpcmsg($method);
    $client=new xmlrpc_client("/rpc", "localhost","6800");
    $result = $client->send($message);
    return $result;
}

function setXMLRPCdata($method, $gid, $member, $value) {
    if ($gid > 0)
        $message = new xmlrpcmsg($method, array(new xmlrpcval($gid, "string")));
    else
        $message = new xmlrpcmsg($method, array(new xmlrpcval(array($member => new xmlrpcval($value, "string")), "struct")));
    $client=new xmlrpc_client("/rpc", "localhost","6800");
    $result = $client->send($message);
    return $result;
}

function getXMLRPCvalue($gid, $value_reqd) {
    $result = getXMLRPCdata('aria2.tellStatus', $gid);
    $value = 0;
    $status='';
    if (! $result->faultCode()) {
        $struct = $result->value();
        $ret_array=array();
        foreach($value_reqd as $values) {
            if ($status == 'active' || $status == '') {
                $value_raw = $struct->structmem($values);
                $value = $value_raw->scalarval();
                $ret_array = array_push_assoc($ret_array, $values, $value);
                if ($values == 'status')
                    $status=$value;
            }
        }
    }
    return $ret_array;
}

function killGid($gid) {
    $result = getXMLRPCdata('aria2.remove', $gid);
}

function isGIDActive($gid) {
    $result = getXMLRPCdata('aria2.tellStatus', $gid);
    if (! $result->faultCode()) {
        $struct = $result->value();
        $status_raw = $struct->structmem('status');
        $status = $status_raw->scalarval();
    }

    if($status == "active") {
        //Pid is running
        return true;
    }else{
        //Pid is not running
        return false;
    }
}

function getURL($url, $opts) {
    if (is_array($opts))
        $options=implode(' ',$opts);
    else
        $options="";

    $command = "wget -q $options $url -qO";

    $data = shell_exec($command);
    return $data;
}

function scan_dir($dir) {
    $dh = opendir($dir);
    while (false !== ($filename = readdir($dh))) {
        $files[]=$filename;
    }
    sort($files);
    return $files;
}

function check_error($lpage) {
    global $error_db;
    $arr = file($error_db);

    foreach($arr as $line) {
        $errordb = explode('|', $line);
        $mystr = $errordb[1];
        $strerror = trim($errordb[2]);
        $strerror = $strerror ? $strerror : $mystr;
        if (stristr($lpage, $mystr))
            return $strerror;
    }
}

function print_version() {
    $appinfo="/share/Apps/DownloadManager/appinfo.json";
    if (file_exists($appinfo)){
    $data = file_get_contents($appinfo);
        if(preg_match("/version=\"(.*)\"/", $data, $version))
            return $version[1];
    }
    else
        return "unknown";
}

function url_decode($url){
    $source = array('&amp;');
    $target = array('&');
    $url=str_replace($source, $target, $url);
    return $url;
}

function url_encode($url){
    $source = array('&');
    $target = array('&amp;');
    $url=str_replace($source, $target, $url);
    return $url;
}
?>
