<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir, $timezone_offset, $utildir;
global $download_db;
$desc=LoadLang();
ini_set("session.save_path", $tmpdir);
session_start();

//XML HEADER

//include XML Header (as response will be in xml format)
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
 		header("Content-type: application/xhtml+xml"); } else {
 		header("Content-type: text/xml");
}
print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"); 
?>

<!-- start grid xml -->
<rows id="0">
<?php
$mode = $_GET["mode"];

switch($mode){
    case "download":
    if (file_exists($download_db) && filesize($download_db) > 0) {
        $dbh = new PDO('sqlite:'.$download_db);

        $sql = "SELECT * FROM links ORDER BY sno";
        $result = $dbh->query($sql);
        $error = $dbh->errorInfo();
        if (!$result){
            $dbh = NULL;
            print($sql."\n");
            die($err[2]);
        }
        $val_reqd=array("status","completedLength","downloadSpeed");

        foreach($result as $row ) {
            //create xml tag for grid row
            $link = $row['link'];
            $filename = $row['filename'];
            if ($row['filesize'] == "unspecified")
                $filesize=0;
            else
                $filesize = $row['filesize'];
            $completed = $row['completed'];
            $gid = $row['gid'];
            $current_start_date = $row['cstart_date'];
            $total_time = $row['total_time'];
            $session_time = $row['session_time'];
            $status = $row['status'];
            $file_exists = $row['file_exists'];
            $last_checked = $row['last_checked'];
            $location = $row['location'];
            $no_of_threads = $row['sections'];
            $speed=0;
            
            if ($gid != 0) {
                $values = getXMLRPCvalue($gid, $val_reqd);
                if($values['status'] == "active") {
                    $completed=$values['completedLength'];
                    $speed=$values['downloadSpeed'];
                }
            }

            $session_time=time()-$current_start_date;

            $style='';
            if ($file_exists == "0")
                $file_exists=$status;

            if ($status == $desc['failed'])
                $style='color:red';
            else
                $style='color:black';

            if ($last_checked == "0")
                $last_checked=$desc['unknown'];
            else
                $last_checked=date($desc['date_format'],$last_checked+$timezone_offset);

            print("<row id='".url_encode($link)."' style='".$style."'>\n");
            print("<cell><![CDATA[".$link."]]></cell>\n");
            if ($status == $desc['loading'])
                print("<cell><![CDATA[_img/".$status.".gif]]></cell>\n");
            else
                print("<cell><![CDATA[_img/".$status.".png]]></cell>\n");
            print("<cell title='".url_encode($link)."'><![CDATA[".$filename."<br/><span style='color:grey'><i>".$file_exists."</i></span>]]></cell>\n");
            // Filesize
            print("<cell><![CDATA[".$filesize."]]></cell>\n");					
            // Completed
            print("<cell><![CDATA[".$completed."]]></cell>\n");
            // Percent
            if ($completed > 0)  {
                $percent = floor((((float)$completed/(float)$filesize)*100)*pow(10,2))/pow(10,2)."%";
                print("<cell><![CDATA[<div class='progressbar' style='padding-bottom:5px;'><div id='percent' class='progressbar-completed' style='width:".$percent."'><div style='padding-top:3px;'>".$percent."</div></div></div>]]></cell>\n");
            }
            else
                print("<cell><![CDATA[<div class='progressbar' style='margin-top:5px;padding-bottom:5px;'><div id='percent' class='progressbar-completed' style='width:0%'><div style='padding-top:3px;'>0%</div></div></div>]]></cell>\n");
            if ($completed > 0) {
                if ($status == $desc['downloading'])
                    print("<cell><![CDATA[".($session_time+$total_time)."]]></cell>\n");
                else
                    print("<cell><![CDATA[".$total_time."]]></cell>\n");
            }
            else
                print("<cell><![CDATA[ ]]></cell>\n");
            // Time Left
            if ($status == $desc['downloading'])
                print("<cell><![CDATA[".round(((float)$filesize-(float)$completed)/$speed,0)."]]></cell>\n");
            else
                print("<cell><![CDATA[ ]]></cell>\n");
            // Speed
            print("<cell><![CDATA[".$speed."]]></cell>\n");
            print("<cell><![CDATA[".$status."]]></cell>\n");
            print("<cell><![CDATA[".$file_exists."]]></cell>\n");
            print("<cell><![CDATA[".$no_of_threads."]]></cell>\n");
            print("<cell><![CDATA[".$last_checked."]]></cell>\n");

            //close xml tag for the row
            print("</row>\n");
        }
    }
    $dbh = NULL;
    break;
    case "sitemgr":
    $dbh = new PDO('sqlite:'.$download_db);
    $sql = "SELECT ROWID,* FROM sitemgr";
    $result = $dbh->query($sql);
    foreach($result as $row ) {
        $none=0;
        $free=0;
        $premium=0;
        if ($row['type'] == 0)
            $none=1;
        else if ($row['type'] == 1)
            $free=1;
        else if ($row['type'] == 2)
            $premium=1;
        if ($row['verified'] == 0)
            $image = "_img/no.png";
        else
            $image = "_img/yes.png";
            
        print("    <row id='".$row['rowid']."'>\n");
        print("        <cell><![CDATA[".$row['site']."]]></cell>\n");
        print("        <cell><![CDATA[".$row['state']."]]></cell>\n");
       print("        <cell><![CDATA[".$none."]]></cell>\n");
        print("        <cell><![CDATA[".$free."]]></cell>\n");
        print("        <cell><![CDATA[".$premium."]]></cell>\n");
        print("        <cell><![CDATA[".$row['username']."]]></cell>\n");
        print("        <cell><![CDATA[".$row['password']."]]></cell>\n");
        print("        <cell><![CDATA[".$row['verified']."]]></cell>\n");
        print("        <cell><![CDATA[".$image."]]></cell>\n");
        //close xml tag for the row
        print("    </row>\n");
    }
    $dbh = NULL;
    break;
}
?>
<!-- close grid xml -->
</rows>	
