<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir, $timezone_offset, $utildir;
global $download_db;
$desc=LoadLang();
ini_set("session.save_path", $tmpdir);
session_start();

//XML HEADER

//include XML Header (as response will be in xml format)
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
 		header("Content-type: application/xhtml+xml"); } else {
 		header("Content-type: text/xml");
}
print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"); 
?>

<?php
if(isset($_GET['xml']) && $_GET['xml'] == 'propform1') {
    print('<items>');
    print('<item type="input" name="editlink" label="URL:" width="500"/>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform2') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="200" inputWidth="220"/>'); 
    print('<item type="fieldset" label="'.$desc['location'].'" width="540" inputHeight="50">');
    print('<item type="label" name="tlocation_label" style="font-weight:normal;" label="'.$desc['downlocation'].'">'); 
    print('<item type="input" name="tlocation" inputLeft="120" inputWidth="250" inputTop="2" readonly="true"/>');
    print('<item type="newcolumn" />');
    print('<item type="button" name="browse" inputLeft="380" inputTop="-1" width="64" value="'.$desc['browse'].'"/></item>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform3') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="250" inputWidth="220"/>'); 
    print('<item type="fieldset" name="connection" label="'.$desc['connection'].'" width="540" inputHeight="50">');
    print('<item type="input" name="noconn" label="'.$desc['no_conn'].' (1-20)" inputLeft="400" inputWidth="60" style="text-align:right;"/>');
    print('</item>');
    print('<item type="fieldset" name="download" label="'.$desc['limits'].'" width="540" inputHeight="70" inputTop="70">');
    print('<item type="checkbox" name="no_speed_limit" label="'.$desc['no_speed_limit'].'" checked="false" labelLeft="22"/>'); 
    print('<item type="input" name="speedlimit" inputLeft="400" inputWidth="60" inputTop="25" label="'.$desc['speed_limit'].' KB/s (1-10000)" labelTop="25" style="text-align: right;" labelLeft="20"/>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform5') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="250" inputWidth="220"/>'); 
    print('<item type="fieldset" label="'.$desc['browsercontext'].'" width="540" inputHeight="190">');
    print('<item type="input" name="referer" inputLeft="140" inputWidth="350" inputTop="2" label="'.$desc['referer'].'"/>');
    print('<item type="input" name="cookie" label="'.$desc['cookie'].'" inputLeft="140" inputTop="27" inputWidth="350" labelTop="25"/>');
    print('<item type="input" name="useragent" label="'.$desc['useragent'].'" inputLeft="140" inputTop="52" inputWidth="350" labelTop="50"/>');
    print('<item type="input" name="extraheaders" label="'.$desc['extraheaders'].'" labelTop="77" inputLeft="140" inputTop="77" inputWidth="350" rows="5"/>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform6') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="200" inputWidth="220"/>'); 
    print('<item type="button" name="ok" inputLeft="230" width="50" value="'.$desc['ok'].'"/>'); 
    print('<item type="newcolumn" />');
    print('<item type="button" name="apply" inputLeft="315" inputTop="5" width="50" value="'.$desc['apply'].'"/>');
    print('<item type="newcolumn" />');
    print('<item type="button" name="cancel" inputLeft="400" inputTop="5" width="50" value="'.$desc['cancel'].'"/>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform7') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="200" inputWidth="220"/>'); 
    print('<item type="fieldset" name="download" label="'.$desc['download'].'" width="580" inputHeight="70">');
    print('<item type="label" inputWidth="200" label="'.$desc['start_m'].'" style="font-weight:normal;"> ');
    print('<item type="radio" name="start_type" label="'.$desc['manual'].'" value="0" labelTop="2" inputTop="2" labelLeft="200" inputLeft="170" />');
    print('<item type="radio" name="start_type" label="'.$desc['immediate'].'" value="1" labelTop="2" inputTop="2" labelLeft="280" inputLeft="250" checked="true"/>');
    print('<item type="radio" name="start_type" label="'.$desc['schedule'].'" value="2" labelTop="2" inputTop="2" labelLeft="380" inputLeft="350"/>');
    print('</item>');
    print('<item type="label" inputWidth="200" labelTop="25" label="'.$desc['mode'].'" style="font-weight:normal;"> ');
    print('<item type="radio" name="start_mode" label="'.$desc['direct'].'" value="0" labelTop="27" inputTop="27" labelLeft="200" inputLeft="170" />');
    print('<item type="radio" name="start_mode" label="'.$desc['plugin'].'" value="1" labelTop="27" inputTop="27" labelLeft="280" inputLeft="250" checked="true"/>');
    print('</item>');
    print('</item>');
    print('<item type="fieldset" name="location" label="'.$desc['location'].'" width="580" inputHeight="50" inputTop="90">');
    print('<item type="label" name="tlocation_label" style="font-weight:normal;" label="'.$desc['downlocation'].'">'); 
    print('<item type="input" name="tlocation1" inputLeft="140" inputWidth="275" inputTop="2" readonly="true"/>');
    print('<item type="newcolumn" />');
    print('<item type="button" name="browse" inputLeft="420" inputTop="-1" width="64" value="'.$desc['browse'].'"/></item>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform8') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="250" inputWidth="220"/>'); 
    print('<item type="fieldset" name="connection" label="'.$desc['connection'].'" width="580" inputHeight="50">');
    print('<item type="input" name="noconn" label="'.$desc['no_conn'].' (1-20)" inputLeft="400" inputWidth="60" style="text-align:right;"/>');
    print('</item>');
    print('<item type="fieldset" name="download" label="'.$desc['limits'].'" width="580" inputHeight="70" inputTop="70">');
    print('<item type="checkbox" name="no_speed_limit" label="'.$desc['no_speed_limit'].'" checked="false" labelLeft="22"/>'); 
    print('<item type="input" name="speedlimit" inputLeft="400" inputWidth="60" inputTop="25" label="'.$desc['speed_limit'].' KB/s (1-10000)" labelTop="25" style="text-align: right;" labelLeft="20"/>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'propform9') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="250" inputWidth="220"/>'); 
    print('<item type="fieldset" label="'.$desc['browsercontext'].'" width="580" inputHeight="190">');
    print('<item type="input" name="referer" inputLeft="140" inputWidth="370" inputTop="2" label="'.$desc['referer'].'"/>');
    print('<item type="input" name="cookie" label="'.$desc['cookie'].'" inputLeft="140" inputTop="27" inputWidth="370" labelTop="25"/>');
    print('<item type="input" name="useragent" label="'.$desc['useragent'].'" inputLeft="140" inputTop="52" inputWidth="370" labelTop="50"/>');
    print('<item type="input" name="extraheaders" label="'.$desc['extraheaders'].'" labelTop="77" inputLeft="140" inputTop="77" inputWidth="370" rows="5"/>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'prefform1') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="500" inputWidth="120"/>'); 
    print('<item type="fieldset" name="general" label="'.$desc['general'].'" width="700" inputHeight="100">');
    print('<item type="select" name="default_lang" label="'.$desc['language'].'" inputLeft="425" />');
    print('<item type="select" name="timezone_offset" label="'.$desc['timezone'].'" labelTop="25" inputTop="25" inputLeft="425" />');
    print('</item>');
    print('<item type="checkbox" name="autoupdate" label="'.$desc['autoupdate'].'" checked="true" labelLeft="50" inputLeft="27" labelTop="77" inputTop="77" />');
    print('<item type="fieldset" name="location" label="'.$desc['location'].'" width="700" inputHeight="100" inputTop="120">');
    print('<item type="label" label="'.$desc['def_location'].'" style="font-weight:normal;"> ');
    print('<item type="input" name="download_location" inputLeft="250" inputTop="2" inputWidth="275" readonly="true"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="download_browse" inputLeft="525" inputTop="-1" width="64" value="'.$desc['browse'].'"/> ');
    print('</item> ');
    print('<item type="label" label="'.$desc['utildir'].'" style="font-weight:normal;" labelTop="25"> ');
    print('<item type="input" name="utils_location" inputLeft="250" inputTop="20" inputWidth="275" readonly="true"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="utils_browse" inputLeft="525" inputTop="17" width="64" value="'.$desc['browse'].'"/> ');
    print('</item> ');
    print('<item type="select" name="overwrite_mode" label="'.$desc['file_exists'].'" labelTop="55" inputTop="55" inputLeft="425">');
    print('<option value="false" text="'.$desc['rename'].'" selected="1" />');
    print('<option value="true" text="'.$desc['overwrite'].'" />');
    print('</item>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'prefform2') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="500" inputWidth="120"/>'); 
    print('<item type="fieldset" name="general" label="'.$desc['downloads'].'" width="700" inputHeight="280">');
    print('<item type="checkbox" name="autostart" label="'.$desc['autostart'].'" checked="true" labelLeft="22"/>');
    print('<item type="checkbox" name="autoclean" label="'.$desc['autoclean'].'" checked="true" labelTop="25" inputTop="25" labelLeft="22"/>');
    print('<item type="checkbox" name="autoshutdown" label="'.$desc['autoshutdown'].'" checked="true" labelTop="50" inputTop="50" labelLeft="22"/>');
    print('<item type="checkbox" name="fileallocation" label="'.$desc['fileallocation'].'" checked="true" labelTop="75" inputTop="75" labelLeft="22"/>');
    print('<item type="checkbox" name="extractcompleted" label="'.$desc['extractcompleted'].'" checked="true" labelTop="100" inputTop="100" labelLeft="22">');
    print('<item type="checkbox" name="deepextraction" label="'.$desc['deepextraction'].'" checked="true" labelTop="125" inputTop="125" labelLeft="22"/>');
    print('<item type="label" inputWidth="200" label="'.$desc['archivedir'].'" labelLeft="5" labelTop="148" style="font-weight:normal;"> ');
    print('<item type="input" name="archivedir" inputLeft="130" inputTop="150" inputWidth="300" readonly="true"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="extract_browse" inputLeft="432" inputTop="147" width="64" value="'.$desc['browse'].'"/> ');
    print('</item> ');
    print('<item type="checkbox" name="deletearchive" label="'.$desc['deletearchive'].'" checked="true" labelTop="175" inputTop="175" labelLeft="22"/>');
    print('<item type="checkbox" name="keepbroken" label="'.$desc['keepbroken'].'" checked="true" labelTop="200" inputTop="200" labelLeft="22"/>');
    print('</item>');
    print('<item type="checkbox" name="timestamp" label="'.$desc['timestamp'].'" checked="true" labelTop="225" inputTop="225" labelLeft="22"/>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'prefform3') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="500" inputWidth="120"/> ');
    print('<item type="fieldset" name="general" label="'.$desc['limits'].'" width="700" inputHeight="150">');
    print('<item type="input" label="'.$desc['maxjobs'].' (1-10)" name="maxjobs" inputLeft="425" inputWidth="60" style="text-align: right;"/>');
    print('<item type="checkbox" name="always_retry" label="'.$desc['always_retry'].'" checked="false" labelLeft="22" labelTop="25" inputTop="25"/>');
    print('<item type="input" label="'.$desc['no_tries'].' (1-999)" name="noretries" inputLeft="425" inputTop="50" inputWidth="60" labelTop="50" labelLeft="20" style="text-align: right;"/> ');
    print('<item type="checkbox" name="no_speed_limit" label="'.$desc['no_speed_limit'].'" checked="false" labelLeft="22" labelTop="75" inputTop="75"/>');
    print('<item type="input" label="'.$desc['speed_limit'].' KB/s (1-10000)" name="speedlimit" inputLeft="425" inputTop="100" inputWidth="60" labelTop="100" labelLeft="20" style="text-align: right;"/> ');
    print('</item>');
    print('<item type="fieldset" name="location" label="'.$desc['connection'].'" width="700" inputHeight="50" inputTop="170">');
    print('<item type="input" label="'.$desc['no_conn'].' (1-20)" name="noconn" inputLeft="425" inputWidth="60" style="text-align: right;"/> ');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'prefform4') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="500" inputWidth="120"/> ');
    print('<item type="fieldset" name="router" label="'.$desc['router'].'" width="700" inputHeight="150">');
    print('<item type="label" inputWidth="200" label="'.$desc['routertype'].'" style="font-weight:normal;"> ');
    print('<item type="radio" name="routertype" label="'.$desc['static'].'" value="0" labelTop="2" inputTop="2" labelLeft="320" inputLeft="300" checked="true"/>');
    print('<item type="radio" name="routertype" label="'.$desc['dynamic'].'" value="1" labelTop="2" inputTop="2" labelLeft="400" inputLeft="380">');
    print('<item type="input" label="'.$desc['routerip'].'" name="routerip" inputLeft="280" inputTop="25" inputWidth="170" labelTop="25" labelLeft="-20" />');
    print('<item type="input" label="'.$desc['routeruser'].'" name="routeruser" inputLeft="280" inputTop="50" inputWidth="170" labelTop="50" labelLeft="-20" />');
    print('<item type="password" label="'.$desc['routerpass'].'" name="routerpass" inputLeft="280" inputTop="75" inputWidth="170" labelTop="75" labelLeft="-20" />');
    print('</item>');
    print('</item>');
    print('</item>');
    print('<item type="checkbox" name="rebootrouter" label="'.$desc['reboot'].'" checked="true" inputTop="127" labelTop="127" labelLeft="70" inputLeft="47"/>');
    print('<item type="fieldset" name="captcha" label="'.$desc['captcha'].'" width="700" inputHeight="150" inputTop="170">');
    print('<item type="checkbox" name="autocaptcha" label="'.$desc['autocaptcha'].'" checked="true" labelLeft="22"/>');
    print('<item type="checkbox" name="autorecaptcha" label="'.$desc['autorecaptcha'].'" labelLeft="22" inputTop="25" labelTop="25">');
    print('<item type="input" label="'.$desc['captchauser'].'" name="captchauser" inputLeft="300" inputTop="50" inputWidth="170" labelTop="50" />');
    print('<item type="input" label="'.$desc['captchapass'].'" name="captchapass" inputLeft="300" inputTop="75" inputWidth="300" labelTop="75" />');
    print('<item type="input" label="'.$desc['api_key'].'" name="api_key" inputLeft="300" inputTop="100" inputWidth="300" labelTop="100" />');
    print('</item>');
    print('</item>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'password') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="300" inputWidth="220"/>'); 
    print('<item type="label" inputWidth="auto" label="'.$desc['passwd'].'" style="font-weight:normal;">'); 
    print('<item type="input" name="password" inputLeft="-20" labelTop="25" inputTop="25" inputWidth="280" />');
    print('</item> ');
    print('<item type="separator" inputLeft="-20" labelTop="50" inputTop="50" inputWidth="610"/> ');
    print('<item type="button" name="ok" inputLeft="100" labelTop="70" inputTop="70" width="50" value="'.$desc['ok'].'"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="cancel" inputLeft="140" labelTop="75" inputTop="75" width="50" value="'.$desc['cancel'].'"/> ');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'addurl') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="350" inputWidth="220"/> ');
    print('<item type="label" inputWidth="auto" label="'.$desc['pasteurl'].'"> ');
    print('<item type="input" name="links" inputLeft="-20" labelTop="25" inputTop="25" inputWidth="590" inputHeight="100" rows="5"/> ');
    print('</item> ');
    print('<item type="separator" inputLeft="-20" labelTop="140" inputTop="140" inputWidth="640"/> ');
    print('<item type="button" name="more" inputLeft="5" labelTop="155" inputTop="155" width="50" value="'.$desc['more'].'"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="add" inputLeft="330" labelTop="165" inputTop="165" width="50" value="'.$desc['add'].'"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="cancel" inputLeft="415" labelTop="165" inputTop="165" width="50" value="'.$desc['cancel'].'"/> ');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'showconfirm') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="400" inputWidth="420"/> ');
    print('<item type="label" label="&amp;nbsp;&amp;nbsp;&amp;nbsp;" labelLeft="5" labelTop="5" style="font-weight:normal;background: url(_img/question.png);width:48px;height:48px;"> ');
    print('<item type="label" width="200" label="'.$desc['unknown_mesg'].'" name="message" inputTop="25" labelLeft="50" labelTop="20" style="font-weight:normal;"/> ');
    print('</item>');
    print('<item type="separator" inputLeft="-20" labelTop="70" inputTop="70" inputWidth="400"/> ');
    print('<item type="button" name="ok" inputLeft="180" labelTop="85" inputTop="85" width="50" value="'.$desc['yes'].'"/> ');
    print('<item type="newcolumn" />');
    print('<item type="button" name="cancel" inputLeft="220" labelTop="90" inputTop="90" width="50" value="'.$desc['no'].'"/> ');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'prefform6') {
    print('<items>');
    print('<item type="settings" position="absolute" labelWidth="200" inputWidth="220"/>'); 
    print('<item type="button" name="reset" inputLeft="15" width="50" value="'.$desc['reset'].'"/>'); 
    print('<item type="newcolumn" />');
    print('<item type="button" name="ok" inputLeft="390" width="50" inputTop="5" value="'.$desc['ok'].'"/>'); 
    print('<item type="newcolumn" />');
    print('<item type="button" name="apply" inputLeft="475" inputTop="5" width="50" value="'.$desc['apply'].'"/>');
    print('<item type="newcolumn" />');
    print('<item type="button" name="cancel" inputLeft="560" inputTop="5" width="50" value="'.$desc['cancel'].'"/>');
    print('</items>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'toolbarDM') {
    print('<toolbar>');
    print('<item id="add" type="button" img="Add_t.png" imgdis="Add_td.png" title="'.$desc['add_t'].'" /> ');
    print('<item id="start" type="button" img="Start_t.png" imgdis="Start_td.png" title="'.$desc['start_t'].'" /> ');
    print('<item id="pause" type="button" img="Pause_t.png" imgdis="Pause_td.png" title="'.$desc['pause_t'].'" /> ');
    print('<item id="delete" type="button" img="Delete_t.png" imgdis="Delete_td.png" title="'.$desc['delete_t'].'" /> ');
    print('<item id="sep00" type="separator" /> ');
    print('<item id="refresh" type="button" img="Refresh_t.png" imgdis="Refresh_t.png" title="'.$desc['refresh_t'].'" /> ');
    print('<item id="sep01" type="separator" /> ');
    print('<item id="moveup" type="button" img="Up_t.png" imgdis="Up_td.png" title="'.$desc['moveup_t'].'" /> ');
    print('<item id="movedown" type="button" img="Down_t.png" imgdis="Down_td.png" title="'.$desc['movedown_t'].'" /> ');
    print('<item id="sep02" type="separator" /> ');
    print('<item id="startall" type="button" img="StartAll_t.png" imgdis="StartAll_t.png" title="'.$desc['startall_t'].'" /> ');
    print('<item id="pauseall" type="button" img="PauseAll_t.png" imgdis="PauseAll_t.png" title="'.$desc['pauseall_t'].'" /> ');
    print('<item id="sep03" type="separator" /> ');
    print('<item id="passwd" type="button" img="Passwd_t.png" imgdis="Passwd_td.png" title="'.$desc['password_t'].'" /> ');
    print('<item id="properties" type="button" img="Properties_t.png" imgdis="Properties_td.png" title="'.$desc['editprop_t'].'" /> ');
    print('<item id="sep04" type="separator" /> ');
    print('<item id="schedule" type="button" img="Schedule_t.png" imgdis="Schedule_td.png" title="'.$desc['schedule_t'].'" /> ');
    print('<item id="options" type="button" img="Configure_t.png" imgdis="Configure_t.png" title="'.$desc['options_t'].'" /> ');
    print('<item id="sep05" type="separator" /> ');
    print('<item id="stop" type="buttonTwoState" img="Go_t.png" imgdis="Go_t.png" title="Stop/Start Downloads" /> ');
    print('<item id="sep06" type="separator" /> ');
    print('<item id="info" type="button" img="Info_t.png" imgdis="Info_t.png" title="'.$desc['info_t'].'" /> ');
    print('</toolbar>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'toolbarSM') {
    print('<toolbar>');
    print('<item id="new" type="button" img="new.png" imgdis="new_dis.png" title="'.$desc['new_t'].'" /> ');
    print('<item id="edit" type="button" img="edit.png" imgdis="edit_dis.png" title="'.$desc['edit_t'].'" /> ');
    print('<item id="del" type="button" img="delete.png" imgdis="delete_dis.png" title="'.$desc['del_t'].'" /> ');
    print('<item id="ver" type="button" img="verify.png" imgdis="verify_dis.png" title="'.$desc['ver_t'].'" /> ');
    print('</toolbar>');
} else if(isset($_GET['xml']) && $_GET['xml'] == 'menu') {
    print('<menu>');
    print('<item id="start" text="'.$desc['start_m'].'" img="start.png" imgdis="start_dis.png"/> ');
    print('<item id="pause" text="'.$desc['pause_m'].'" img="pause.png" imgdis="pause_dis.png"/> ');
    print('<item id="delete" text="'.$desc['delete_m'].'" img="delete.png" imgdis="delete.png"><hotkey>Del</hotkey></item>');
    print('<item id="sep01" type="separator" /> ');
    print('<item id="restart" text="'.$desc['restart_m'].'" img="restart.png" imgdis="restart_dis.png"/> ');
    print('<item id="schedule" text="'.$desc['schedule_m'].'" img="schedule.png" imgdis="schedule_dis.png"/> ');
    print('<item id="sep02" type="separator" /> ');
    print('<item id="startall" text="'.$desc['startall_m'].'" img="startall.png" imgdis="startall_dis.png"/> ');
    print('<item id="pauseall" text="'.$desc['pauseall_m'].'" img="pauseall.png" imgdis="pauseall_dis.png"/> ');
    print('<item id="selectall" text="'.$desc['startall_m'].'" img="select_all.gif" imgdis="select_all_dis.gif"/> ');
    print('<item id="sep03" type="separator" /> ');
    print('<item id="movetop" text="'.$desc['movetop_m'].'" img="movetop.png" imgdis="movetop_dis.png"/> ');
    print('<item id="moveup" text="'.$desc['moveup_m'].'" img="moveup.png" imgdis="moveup_dis.png"/> ');
    print('<item id="movedown" text="'.$desc['movedown_m'].'" img="movedown.png" imgdis="movedown_dis.png"/> ');
    print('<item id="movebtm" text="'.$desc['movebtm_m'].'" img="movebottom.png" imgdis="movebottom_dis.png"/> ');
    print('<item id="sep05" type="separator" /> ');
    print('<item id="archivepass" text="'.$desc['password_t'].'" img="password.png" imgdis="password.png"/> ');
    print('<item id="sep06" type="separator" /> ');
    print('<item id="properties" text="'.$desc['editprop_t'].'" img="properties.png" imgdis="properties.png"><hotkey>Dbl Click</hotkey></item> ');
    print('</menu>');
}
?>
