<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $download_db, $downloaddir, $no_of_threads, $autostart;
global $tmpdir, $utildir, $homedir;

//start session to build different grids for different sessions
ini_set("session.save_path", $tmpdir);
session_start();

//XML HEADER
//include XML Header (as response will be in xml format)
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
 		header("Content-type: application/xhtml+xml"); } else {
 		header("Content-type: text/xml");
}

$mode = $_GET["!nativeeditor_status"]; //get request mode
$rowId = $_GET["gr_id"]; //id or row which was updated 
$newId = $_GET["gr_id"]; //will be used for insert operation
$text1 = '';
$text2 = '';
$action = '';

LoadPreferences();
$desc=LoadLang();

// Open the DB
$dbh = new PDO('sqlite:'.$download_db);

if (isset($_GET["link"]) || isset($_GET["links"])) {
    switch($mode){
    case "inserted":
        //INSERT
        // Get values from post data
        $links = explode("#",rawurldecode($_GET["link"]));
        $extraheaders=$links[count($links)-1];
        array_pop($links);
        $useragent=$links[count($links)-1];
        array_pop($links);
        $cookie=$links[count($links)-1];
        array_pop($links);
        $referer=$links[count($links)-1];
        array_pop($links);
        $speedlimit=$links[count($links)-1];
        array_pop($links);
        $noconn=$links[count($links)-1];
        array_pop($links);
        $plugmode=$links[count($links)-1];
        array_pop($links);
        $starttype=$links[count($links)-1];
        array_pop($links);
        $downloaddir=$links[count($links)-1];
        array_pop($links);

        foreach($links as $link) {
            if (preg_match("/http\:\/\//", $link) || preg_match("/ftp\:\/\//", $link) || 
                preg_match("/https\:\/\//", $link)) {
                /* explode the links at new line tag */
                $new_links = explode("\n", $link);

                if ($starttype == 0)
                    $status='Pause';
                else if ($starttype == 1)
                    $status='Waiting';
                else if ($starttype == 2)
                    $status='Scheduled';

                for($i=0; $i < count($new_links); $i++) {
                    if ($new_links[$i] != "") {
                        $sql = "SELECT MAX(ROWID) FROM links";
                        $result=$dbh->query($sql);
                        $row = $result->fetch();
                        $sql = 'INSERT INTO links(link,filename,filesize,completed,gid,start_date,end_date,
		                  cstart_date,total_time,session_time,status,file_exists,last_checked,
                                  location,sections,password,sno,speed_limit,referer,cookie,useragent,
                                  extraheaders,mirrors,mode) ';
                        $sql .= 'VALUES("'.url_decode(trim($new_links[$i])).'",';
                        $sql .= '"'.url_decode(basename(trim($new_links[$i]))).'",0,';
                        $sql .= '0,0,0,0,0,0,0,"'.$status.'",0,0,"'.$downloaddir.'",';
                        $sql .= $noconn.',"",'.++$row[0].','.$speedlimit.',"'.$referer.'",';
                        $sql .= '"'.$cookie.'","'.trim($useragent).'",';
                        $sql .= '"'.$extraheaders.'","",'.$plugmode.')';
                        $result=$dbh->query($sql);
                    }
                }
            }
        }
        //set value to use in response
        $action = "insert";
    break;
    case "deleted":
        //DELETE
        $links = explode(",",rawurldecode($_GET["links"]));

        foreach($links as $link) {
            $sql = 'DELETE FROM links WHERE link="'.$link.'"';
            $sql .= ' AND status != "Downloading"';
            $result=$dbh->query($sql);
        }

        $action = "delete";
    break;
    case "start_download":
        // Get values from post data
        $links = explode(",",rawurldecode($_GET["links"]));

        if (file_exists($utildir."bin/aria2c") && file_exists($utildir."bin/aria2-xmlrpc")) {
            foreach($links as $link) {
                $sql = 'UPDATE links SET status="Waiting",file_exists="Waiting" ';
                $sql .= 'WHERE link="'.$link.'" ';
                $sql .= 'AND status!="Complete" AND status!="Downloading" ';
                $sql .= 'AND status!="Connecting" AND status!="Loading"';
                $result=$dbh->query($sql);
            }
            $action = "update";
        }
        else {
            $action = "error";
            $text1 = $desc['binerror1'];
            $text2 = $desc['binerror2'];
        }
    break;
    case "restart_download":
        // Get values from post data
        $links = explode(",",rawurldecode($_GET["links"]));

        foreach($links as $link) {
            $sql = 'SELECT location,filename FROM links WHERE link="'.$link.'" ';
            $sql .= 'AND status!="Downloading" AND status!="Connecting" AND status!="Loading"';
            $result=$dbh->query($sql);
            $row = $result->fetch(PDO::FETCH_ASSOC);

            if ($row['filename'] == ""){
                $sql = 'UPDATE links SET filename="'.basename($link).'" WHERE link="'.$link.'"';
                $result=$dbh->query($sql);
            }

            if (file_exists($row['location'].$row['filename']))
                unlink($row['location'].$row['filename']);
            if (file_exists($row['location'].$row['filename'].'.aria2'))
                unlink($row['location'].$row['filename'].'.aria2');
            $sql = 'UPDATE links SET completed=0, gid=0, start_date=0,end_date=0, cstart_date=0,';
            $sql .= 'total_time=0, session_time=0, status="Waiting", file_exists="Waiting" ';
            $sql .= 'WHERE link="'.$link.'" ';
            $sql .= 'AND status!="Downloading" AND status!="Connecting" AND status!="Loading"';
            $result=$dbh->query($sql);
        }
        $action = "update";
    break;
    case "pause_download":
        // Get values from post data
        $links = explode(",",rawurldecode($_GET["links"]));

        foreach($links as $link) {
            $sql = 'SELECT gid FROM links WHERE link="'.$link.'"';
            $result=$dbh->query($sql);

            $row = $result->fetch(PDO::FETCH_ASSOC);

            if($row['gid'])
                killGid($row['gid']);

            $sql = 'UPDATE links SET status="Pause",';
            $sql .= 'gid=0,file_exists="Paused" ';
            $sql .= 'WHERE link="'.$link.'" AND status!="Complete"';
            $result=$dbh->query($sql);
        }
        $action = "update";
    break;
    case "order_links":
        // Get values from post data
        $links = explode(",",rawurldecode($_GET["links"]));

        // Get values from post data
        $count = 1;
        foreach($links as $link) {
            // Get values from post data
            $sql = 'UPDATE links SET sno='.$count++.' WHERE link="'.$link.'"';
            $result=$dbh->query($sql);
        }
        $action = "update";
    break;
    case "update_link":
        // Get values from post data
        $links = explode(",",rawurldecode($_GET["links"]));
        $variable = $_GET["variable"];
        $value = $_GET["value"];

        foreach($links as $link) {
            $sql = 'UPDATE links SET '.$variable.'="'.$value.'"';
            $sql .= ' WHERE link="'.$link.'"';
            $result=$dbh->query($sql);

            if ($variable == "speed_limit"){
                $sql = 'SELECT gid,status from links';
                $sql .= ' WHERE link="'.$link.'"';
                $result=$dbh->query($sql);
                $row = $result->fetch(PDO::FETCH_ASSOC);
                if ($row['status'] == 'Downloading') {
                    // Set the dynamic preferences of aria2c
                        setXMLRPCdata('aria2.changeOption', $row['gid'], 'max-download-limit', $value.'K');
                }
            }
        }

        $action = "update";
    break;
    }
} else if (isset($_GET["site"])){
    switch($mode){
    case "inserted":
        $sql = 'INSERT INTO sitemgr VALUES("'.$_GET['site'].'",1,0,"none","none",0)';
        $result=$dbh->query($sql);
        $action = "insert";
    break;
    case "deleted":
        $sql = 'DELETE FROM sitemgr WHERE site="'.$_GET['site'].'"';
        $result=$dbh->query($sql);
        $action = "delete";
    break;
    case "updated":
        $none = $_GET["none"];
        $free = $_GET["free"];
        $premium = $_GET["premium"];
        $verified = $_GET["verified"];
        if ($none == 1)
            $type=0;
        else if ($free == 1)
            $type=1;
        else if ($premium == 1)
            $type=2;

        if ($_GET['user'] == "none" || $_GET['password'] == "none")
            $verified=0;

        $sql = 'UPDATE sitemgr SET site="'.$_GET['site'].'",';
        $sql .= 'state='.$_GET['state'].',';
        $sql .= 'type='.$type.',';
        $sql .= 'username="'.$_GET['user'].'",';
        $sql .= 'password="'.$_GET['password'].'",';
        $sql .= 'verified='.$verified.' ';
        $sql .= 'WHERE ROWID='.$_GET['gr_id'];
        $result=$dbh->query($sql);

        $action = "update";
    break;
    }
}

$dbh = NULL;
////////////////////////////////////////////////////////////
print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"); 
?>
<!-- response xml -->
<data>
<?php 
    print('<action type="'.$action.'" sid="'.url_encode($rowId).'" tid="'.url_encode($newId).'" text1="'.$text1.'" text2="'.$text2.'"/>'); 
?>
</data>
