#!/bin/sh
# This file is part of Download Manager.
#
# Download Manager is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Download Manager is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Download Manager.  If not, see <http://www.gnu.org/licenses/>.

URL=$1
USER=$2
PASS=$3
MODE=$4
TYPE=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    if [ $TYPE -eq 0 -o $TYPE -eq 1 ];then
        PAGE=$(WGET -qO- "$URL") || return 1
        if match "file link that you requested is not valid" "$PAGE"; then
            echo "Error: Invalid link."
            exit 1
        fi

        FILE_URL=$(echo "$PAGE" | parse 'window.location' "='\([^']*\)")
        if [ "$FILE_URL" = "" ];then
            echo "Error: Script Error. Site Update?"
            exit 1
        fi
        echo "$FILE_URL"
    else
        #
        # Premium Account
        #
        $ECHO "Error: Premium Not yet implemented||"
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
