#!/bin/sh                                                                                                     
# This file is part of Download Manager.
#                                                    
# Download Manager is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Download Manager is distributed in the hope that it will be useful,                             
# but WITHOUT ANY WARRANTY; without even the implied warranty of           
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#                                         
# You should have received a copy of the GNU General Public License          
# along with Download Manager.  If not, see <http://www.gnu.org/licenses/>.

URL=$1
MODE=$2
TYPE=$3
USER=$4
PASS=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    html_data=$(wget "$URL" -qO-)

    Output=$(check_error megashares.com "$html_data")
    if [ "$Output" = "" ];then
        #
        # Free/Anonymous Account
        #
        if [ $TYPE -eq 0 -o $TYPE -eq 1 ];then
            if [ "$autocaptcha" = "false" ];then
                echo "Error: Autocaptcha disabled. Cannot continue."
                exit
            fi
            Output=$(echo "$html_data"|grep 'Your Passport needs to be reactivated.')
            if [ "$Output" != "" ];then
                captcha_len=0
                while [ $captcha_len -ne 5 ]
                do
                    html_data=$(wget "$URL" -qO-)
                    imgurl=$(echo "$html_data"|grep 'Security Code'|cut -d'"' -f2)
                    if [ "$imgurl" != "" ];then
                        captcha_img_url="http://megashares.com/${imgurl}"
                        wget -q "$captcha_img_url" -O $TMP2
                        captcha_text=$($CAT $TMP2|$CONVERT - _data/overlay.png -compose ChangeMask  -composite png:- |convert - -compress none -depth 8 -background white -flatten -resize 102x27 tif:-|ocr|$SED "s/[^0-9]//g")
                        $RM -f $TMP2
                        captcha_len=$(echo "$captcha_text"|$WC -c)
                    else
                        break
                    fi
                done
                random_num=$(echo "$html_data"|grep random_num|grep hidden|cut -d'"' -f8)
                passport_num=$(echo "$html_data"|grep passport_num|grep hidden|cut -d'"' -f8)
                URL2=$(echo "$html_data"|grep 'download file'|cut -d'"' -f2)
                rndtime=$(date +%s000)
                final_link="${URL}&rs=check_passport_renewal&rsargs[]=${captcha_text}&rsargs[]=${random_num}&rsargs[]=${passport_num}&rsargs[]=replace_sec_pprenewal&rsrnd=${rndtime}"
                html_data=$(wget "$final_link" -qO-)
                Output=$(echo "$html_data"|grep 'Thank you for reactivating your passport')
                if [ "$Output" != "" ];then
                    echo "${URL2}|"
                else
                    echo "Error: An error occured while retrieving URL"
                fi
            else
                URL2=$(echo "$html_data"|grep 'download file'|cut -d'"' -f2)
                if [ "$URL2" != "" ];then
                    echo "${URL2}|"
                else
                    echo "Error: An error occured while retrieving URL"
                fi
            fi
        else
            #
            # Premium Account
            #
            #
            if [ ! -f "${tmpdir}/.ms_cookie" ];then
                post_data="mymslogin_name=${USER}&mymspassword=${PASS}&myms_login=Login"
                html_data=$(wget --save-cookies=_tmp/.ms_cookie --post-data=${post_data} http://d01.megashares.com/myms_login.php -O- 2>&1)
                Output=$(check_error megashares.com "$html_data")
                if [ "$Output" != "" ];then
                    echo $Output
                    exit 1
                fi
            else
                html_data=$(wget "$URL" --load-cookies=_tmp/.ms_cookie -qO-)
                URL2=$(echo "$html_data"|grep 'download file'|cut -d'"' -f2)
                echo "${URL2}|"
            fi
        fi
    else
        echo $Output
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    post_data="mymslogin_name=${USER}&mymspassword=${PASS}&myms_login=Login"
    html_data=$(wget --save-cookies=$TMPDIR/.ms_cookie --post-data=${post_data} http://d01.megashares.com/myms_login.php -qO-)
    if match "Error during login" "$html_data"; then
        rm -f $TMPDIR/.ms_cookie
        echo "Error: Error during login - Password does not match Username."
        exit 1
    fi
    if [ -s "$TMPDIR/.ms_cookie" ];then
        echo "Verified."
    else
        rm -f $TMPDIR/.ms_cookie
        echo "Error: Failed to set Megashares cookie."
        exit 1
    fi
fi
