#!/bin/sh
set -x
# This file is part of Download Manager.
#
# Download Manager is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Download Manager is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Download Manager.  If not, see <http://www.gnu.org/licenses/>.

URL=$1
MODE=$2
TYPE=$3
USER=$4
PASS=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    MAINPAGE=$(wget "$URL" -qO-)

    if match "has been deleted" "$MAINPAGE"; then
        echo "This file doesn't exit or has been deleted."
        exit
    fi
    if [ $TYPE -eq 0 ];then
        #
        # Anonymous Account
        #
        WAITPAGE=$(wget "${URL}" --post-data="free_download=1" -qO-)
        WAIT=$(echo "$WAITPAGE" | parse "Please wait" "warten(\([[:digit:]]\+\))")
        if [ "$WAIT" != "" ];then
            log_debug "$URL" "Loading download in $WAIT seconds"
            updateDBValue link "${URL}" status "Loading"
            updateDBValue link "${URL}" file_exists "Loading download in $WAIT seconds..."
            sleep ${WAIT}
        fi
        URL2=$(echo "$WAITPAGE" | parse 'form method="post"' 'action="\([^"]*\)"')
        echo "${URL2}|"
        exit 1
    else
        #
        # Premium Account
        #
        echo "Error: Free/Premium Not yet implemented||"
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
