#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+

URL=$1
MODE=$2
TYPE=$3
USER=$4
PASS=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    html_data=`wget "$URL" -qO-`

    Output=`check_error netload.in "$html_data"`
    if [ "$Output" = "" ];then
        if [ $TYPE -eq 0 ];then
            #
            # Free/Anonymous Account
            #
            echo "Error: Free Not yet implemented| "
            exit 1
        else
            #
            # Premium Account
            #
            if [ -f "${TMPDIR}/.nl_cookie_user_value" ];then
                nl_cookie_user_value=$(cat "${TMPDIR}/.nl_cookie_user_value")
            else
                post_data="txtuser=${USER}&txtpass=${PASS}&txtcheck=login&txtlogin=";
                html_data=$(wget http://www.netload.in/ --no-check-certificate --save-headers --post-data=${post_data} -qO-)
                nl_cookie=$(echo "$html_data"|grep 'Set-Cookie:'|cut -d';' -f1|cut -d' ' -f2|cut -d'=' -f2)
                if [ "$nl_cookie" != "" ];then
                    echo $nl_cookie > "${TMPDIR}/.nl_cookie_user_value"
                    nl_cookie_user_value=$(cat "${TMPDIR}/.nl_cookie_user_value")
                else
                    echo "Error: Netload cookie not set. Check Login and/or Password."
                    exit 1
                fi
            fi
    
            if [ "$nl_cookie_user_value" != "" ];then
                header="cookie_user=$nl_cookie_user_value"
                option="Cookie: $header"
                echo "${URL}|$option"
            fi
        fi
    else
        echo $Output
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    post_data="txtuser=${USER}&txtpass=${PASS}&txtcheck=login&txtlogin=";
    html_data=$(wget http://www.netload.in/ --no-check-certificate --save-headers --post-data=${post_data} -qO-)
    nl_cookie=$(echo "$html_data"|grep 'Set-Cookie:'|cut -d';' -f1|cut -d' ' -f2|cut -d'=' -f2)
    if [ "$nl_cookie" != "" ];then
        echo $nl_cookie > "${TMPDIR}/.nl_cookie_user_value"
        nl_cookie_user_value=$(cat "${TMPDIR}/.nl_cookie_user_value")
        echo "Verified."
    else
        echo "Error: Netload cookie not set. Check Login and/or Password."
        exit 1
    fi
fi
