#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+

URL=$1
USER=$2
PASS=$3
MODE=$4
TYPE=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    html_data=`${WGET} "$URL" -qO-`

    Output=`check_error turboshare.com "$html_data"`
    if [ "$Output" = "" ];then
        if [ $TYPE -eq 0 ];then
            #
            # Free/Anonymous Account
            #
            op=`$ECHO "$html_data"|$GREP 'name="op"'|$CUT -d'"' -f6`
            id=`$ECHO "$html_data"|$GREP 'name="id"'|$CUT -d'"' -f6`
            fname=`$ECHO "$html_data"|$GREP 'name="fname"'|$CUT -d'"' -f6`
            referer=`$ECHO "$html_data"|$GREP 'name="referer"'|$CUT -d'"' -f6`
            method_free=`$ECHO "$html_data"|$GREP 'name="method_free"'|$CUT -d'"' -f6`
            post_data="op=${op}&id=${id}&fname=${fname}&referer=${referer}&method_free=${method_free}"
            html_data=`${WGET} --post-data="${post_data}" "$URL" -qO-`
    
            WAIT=`$ECHO "$html_data"|$GREP countdown|$CUT -d'>' -f4|$CUT -d'<' -f1`
            if [ "$WAIT" != "" ];then
                updateDBValue link "${URL}" status "Loading"
                updateDBValue link "${URL}" file_exists "Loading download in $WAIT seconds..."
                $SLEEP ${WAIT}
            fi
    
            op=`$ECHO "$html_data"|$GREP 'name="op"'|$CUT -d'"' -f6`
            id=`$ECHO "$html_data"|$GREP 'name="id"'|$CUT -d'"' -f6`
            rand=`$ECHO "$html_data"|$GREP 'name="rand"'|$CUT -d'"' -f6`
            referer=`$ECHO "$html_data"|$GREP 'name="referer"'|$CUT -d'"' -f6`
            method_free=`$ECHO "$html_data"|$GREP 'name="method_free"'|$CUT -d'"' -f6`
            down_script=`$ECHO "$html_data"|$GREP 'name="down_script"'|$CUT -d'"' -f6`
            post_data="op=${op}&id=${id}&rand=${rand}&referer=${referer}&method_free=${method_free}&down_script=${down_script}"
           
            ${WGET} --post-data="${post_data}" "$URL" -O $TMP1 2>${tmpdir}/test.header
            $ECHO "${URL2}|"
        else
            #
            # Premium Account
            #
            $ECHO "Error: Premium Not yet implemented||"
        fi
    else
        $ECHO $Output
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
