#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+

URL=$1
USER=$2
PASS=$3
MODE=$4
TYPE=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    html_data=`wget --cookies=on --cache=on --save-cookies=$TMP2 --save-headers "$URL" -qO-`

    Output=`check_error uploading.com "$html_data"`
    if [ "$Output" = "" ];then
        if [ $TYPE -eq 0 -o $TYPE -eq 1 ];then
            #
            # Free/Anonymous Account
            #
            Output=`echo "$html_data"|grep 'Sorry, you have reached your daily download limit.'`
            if [ "$Output" != "" ];then
                # Check Static or Dynamic IP Address
                if [ $routertype -eq 0 ];then
                    echo "Error: Sorry, you have reached your daily download limit."
                    exit 1
                else
                    if [ "$rebootrouter" = "true" ];then
                        echo "Reboot:600"
                    else
                        echo "Error: Sorry, you have reached your daily download limit."
                    fi
                fi
                # End Check Static or Dynamic IP Address
            fi
            BASE_URL="http://uploading.com"
            URL1=`echo "$html_data"|grep '"downloadform"'|cut -d'"' -f2`
            file_id=`echo "$html_data"|grep 'name="file_id"'|cut -d'"' -f6`
            code=`echo "$html_data"|grep 'name="code"'|cut -d'"' -f6`
            cookie1=`echo "$html_data"|grep 'SID='|cut -d' ' -f2|cut -d';' -f1`
            cookie2=`echo "$html_data"|grep 'cache='|cut -d' ' -f2|cut -d';' -f1`
            html_data=`${WGET} --load-cookies=$TMP2 --post-data="action=second_page&file_id=${file_id}&code=${code}" "$URL1" -qO-`
        
            Output=`check_error uploading.com "$html_data"`
            if [ "$Output" = "" ];then
                WAIT=`echo "$html_data"|grep 'start_timer'|grep ';'|cut -d')' -f1|cut -d'(' -f2`
                if [ "$WAIT" != "" ];then
                    updateDBValue link "${URL}" status "Loading"
                    updateDBValue link "${URL}" file_exists "Loading download in $WAIT seconds..."
                    sleep ${WAIT}
                fi
                date=`$DATE +%s000000`
                URL2="$BASE_URL/files/get/?JsHttpRequest=${date}-xml"
                html_data=`${WGET} --load-cookies=$TMP2 --post-data="action=get_link&file_id=${file_id}&code=${code}&pass=undefined" "$URL2" -qO-`
                URL2=`echo "$html_data"|cut -d'"' -f12|sed 's|\\\\||g'`
                if [ "$URL2" != "" ];then
                    echo "${URL2}|Cookie: ${cookie1};${cookie2}"
                    rm $TMP2
                else
                    echo "Error: Download url error , Please wait for some time and reattempt"
                fi
            else
                echo $Output
                exit 1
            fi
        else
            #
            # Premium Account
            #
            echo "Error: Premium Not yet implemented||"
            exit 1
        fi
    else
        echo $Output
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
