#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+

URL=$1
USER=$2
PASS=$3
MODE=$4
TYPE=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    #
    # Download Mode
    #
    # Check the URL for existence
    html_data=`wget "$URL" -qO-`

    Output=`check_error x7.to "$html_data"`
    if [ "$Output" = "" ];then
        if [ $TYPE -eq 0 ];then
            #
            # Anonymous Account
            #
            ref_fid=`echo "$html_data"|grep ref_file|cut -d"'" -f4|cut -d'=' -f3|cut -d'&' -f1`
            post_data="ref=ref_user=6649&ref_file=${ref_fid}&url=&date=1234567890"
            html_data=`wget --post-data="cookie_test=enabled; ${post_data}" --referer="${URL}" http://x7.to/james/ticket/dl/${ref_fid} -qO-`
            Type=`echo "$html_data"|cut -d"'" -f2`
            WAIT=`echo "$html_data"|cut -d"," -f2|cut -d':' -f2`
            URL2=`echo "$html_data"|cut -d"'" -f4`
            if [ "$Type" = "download" ];then
                if [ "$WAIT" != "" ];then
                    updateDBValue link "${URL}" status "Loading"
                    updateDBValue link "${URL}" file_exists "Loading download in $WAIT seconds..."
                    sleep ${WAIT}
                fi
                echo "${URL2}|"
                exit 1
            else
                # Check Static or Dynamic IP Address
                if [ $routertype -eq 0 ];then
                    echo "Wait:600"
                    exit 1
                else
                    if [ "$rebootrouter" = "true" ];then
                        echo "Reboot:600"
                        exit 1
                    else
                        echo "Error: You have reached the download limit for free-users."
                        exit 1
                    fi
                fi
            fi
        elif [ $TYPE -eq 1 ];then
            echo "Error: Free Not yet implemented||"
            exit 1
        elif [ $TYPE -eq 2 ];then
            echo "Error: Premium Not yet implemented||"
            exit 1
        fi
    else
        echo $Output
        exit 1
    fi
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
