#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+

URL=$1
MODE=$2
TYPE=$3
USER=$4
PASS=$5

# Load the common functions
. _scripts/lib.sh

if [ "$MODE" = "download" ];then
    detect_javascript >/dev/null 
    if [ "$?" -eq 1 ];then
        echo "Error: Javascript not installed."
        exit 1
    fi

    WAITPAGE=$(wget -S -O- --post-data="download=1" "$URL" 2>&1)
    if match "File Not Found" "$WAITPAGE"; then
        echo "Error: File not found"
        log_debug "$URL" "File not found"
        exit 1
    fi
    COOKIE=$(echo "$WAITPAGE"|grep 'Set-Cookie:'|sed 's|  Set-Cookie: |Cookie: |g')

    WAITTIME=$(echo "$WAITPAGE" | parse "document|important||here" \
        "||here|\([[:digit:]]\+\)")
    if [ "$WAITTIME" = "" ];then
        echo "Error: Unable to get wait time."
        log_debug "$URL" "Unable to get wait time."
        exit 1
    fi

    log_debug "$URL" "Loading download in $WAITTIME seconds"
    updateDBValue link "${URL}" file_exists "Loading download in $WAITTIME seconds..."
    sleep $WAITTIME

    JSCODE=$(echo "$WAITPAGE" | grep "var link_enc")

    FILE_URL=$(echo "$JSCODE" "; print(link);" | javascript)
    FILENAME=$(echo "$WAITPAGE" |parse '<h2>[Dd]ownload:' '<h2>[Dd]ownload:[[:space:]]*\([^<]*\)')

    echo "${FILE_URL}|${COOKIE}"
elif [ "$MODE" = "verify" ];then
    echo "Error: Not yet Implemented. Please PM your credentials to the author to write the premium plugin."
    exit 1
fi
