#!/bin/sh
# This file is part of Download Manager.
#
# Download Manager is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Download Manager is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Download Manager.  If not, see <http://www.gnu.org/licenses/>.

# Load the common functions
. _scripts/lib.sh

autoupdate=$(selectDBValue preferences value variable autoupdate)

#Change the directory to $homedir
cd $homedir

CurrentVersion=$(cat _data/version)
PatchData=$(wget -qO- --no-cache http://nmtprogs.googlecode.com/files/version.txt|sed 's|
||g')
OnlineVersion=$(echo "$PatchData"|grep version=|cut -d'=' -f2)
PatchZip=$(echo "$PatchData"|grep patchfile=|cut -d'=' -f2)

if [ "$CurrentVersion" != "$OnlineVersion" ];then
    echo "New patch is available online."
    if [ "$autoupdate" = "true" ];then
        echo "Downloading $PatchZip"
        wget -q http://nmtprogs.googlecode.com/files/${PatchZip} -O _update/${PatchZip}
        if [ -f "_update/${PatchZip}" -a -s "_update/${PatchZip}" ];then
            cd $TMPDIR && unzip ../_update/${PatchZip} && cd ..
            echo "Updating..."
            tar xvf $TMPDIR/patch.tar
            echo "Done."
            rm -f $TMPDIR/patch.tar
        fi
    fi
else
    echo "Version is upto date."
fi
