#!/bin/sh
# Uncomment Following line to debug the script
# set -x
# +-----------------------------------------------------------------------+
# |                                                                       |
# | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
# | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
# | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
# | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
# | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
# | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
# | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
# | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
# | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
# | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
# | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
# |                                                                       |
# +-----------------------------------------------------------------------+
#
# verify_password.sh:
# Arguments: URL (e.g http://rapidshare.com) user password
#

URL=$1
USER=$2
PASS=$3

# Load the common functions
. _scripts/lib.sh

##
## Rapidshare Premium
##
if [ "$URL" = "http://netload.in" ];then
    # Set post-data
    post_data="txtuser=${USER}&txtpass=${PASS}&txtcheck=login&txtlogin="

    # Fetch login data 
    html_data=`${WGET} http://www.netload.in/ --save-cookies=${tmpdir}/.nlcookie --post-data=${post_data} -qO-`
    Output=`echo "$html_data"|grep 'insert a password or it might be invalid'`
    if [ "$Output" != "" ];then
        echo "Error: You didn't insert a password or it might be invalid!"
        $RM ${tmpdir}/.nlcookie
        exit 1
    fi
    nl_cookie=`$CAT "${tmpdir}/.nlcookie"|grep 'netload.in'|cut -d'	' -f7`

    if [ "$nl_cookie" != "" ];then
        echo "$nl_cookie" > "${tmpdir}/.nl_cookie_user_value"
        $RM ${tmpdir}/.nlcookie
        echo "Verified."
    else
        echo "Error: Failed to get Netload cookie."
        $RM ${tmpdir}/.nlcookie
        exit 1
    fi
##
## Hotfile Premium
##
elif [ "$URL" = "http://hotfile.com" ];then
    # Set post-data
    post_data="user=${USER}&pass=${PASS}"

    # Fetch login data 
    html_data=`${WGET} http://www.hotfile.com/login.php --save-cookies=${tmpdir}/.hfcookie --post-data=${post_data} -qO-`
    Output=`echo "$html_data"|grep 'Bad username/password combination'`
    if [ "$Output" != "" ];then
        echo "Error: Bad username/password combination."
        $RM ${tmpdir}/.hfcookie
        exit 1
    fi
    hf_cookie=`$CAT "${tmpdir}/.hfcookie"|grep 'hotfile.com'|cut -d'	' -f7`

    if [ "$hf_cookie" != "" ];then
        echo "$hf_cookie" > "${tmpdir}/.hf_cookie_user_value"
        $RM ${tmpdir}/.hfcookie
        echo "Verified."
    else
        echo "Error: Failed to get Hotfile cookie."
        $RM ${tmpdir}/.hfcookie
        exit 1
    fi
##
## Megashares Premium
##
elif [ "$URL" = "http://megashares.com" ];then
    # Set post-data
    post_data="mymslogin_name=${USER}&mymspassword=${PASS}&myms_login=Login"

    # Fetch login data 
    html_data=`${WGET} --save-cookies=${tmpdir}/.ms_cookie --post-data=${post_data} http://d01.megashares.com/myms_login.php -qO-`
    Output=`echo "$html_data"|grep 'Bad username/password combination'`
    if [ "$Output" != "" ];then
        echo "Error: Bad username/password combination."
        $RM ${tmpdir}/.mscookie
        exit 1
    fi
    ms_cookie=`$CAT "${tmpdir}/.mscookie"|grep 'hotfile.com'|cut -d'	' -f7`

    if [ "$ms_cookie" != "" ];then
        echo "$ms_cookie" > "${tmpdir}/.ms_cookie_user_value"
        $RM ${tmpdir}/.mscookie
        echo "Verified."
    else
        echo "Error: Failed to get Megashares cookie."
        $RM ${tmpdir}/.mscookie
        exit 1
    fi
##
## Megaupload Premium
##
elif [ "$URL" = "http://megaupload.com" ];then
    # Set post-data
    post_data="login=1&username=${USER}&password=${PASS}"

    # Fetch login data 
    html_data=`${WGET} http://www.megaupload.com --save-cookies=${tmpdir}/.mucookie --post-data=${post_data} -qO-`
    Output=`echo "$html_data"|grep 'Username and password do not match'`
    if [ "$Output" != "" ];then
        echo "Error: Username and password do not match. Please try again!"
        $RM ${tmpdir}/.mucookie
        exit 1
    fi
    mu_cookie=`$CAT "${tmpdir}/.mucookie"|grep 'megaupload.com'|cut -d'	' -f7`

    if [ "$mu_cookie" != "" ];then
        echo "$mu_cookie" > "${tmpdir}/.mu_cookie_user_value"
        $RM ${tmpdir}/.mucookie
        echo "Verified."
    else
        echo "Error: Failed to get Megaupload cookie."
        $RM ${tmpdir}/.mucookie
        exit 1
    fi
fi
